﻿using ProjectGasMachine.Drawnings;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectGasMachine.CollectionGenericObjects;

/// <summary>
/// Сравнение по типу, скорости, весу
/// </summary>
public class DrawningMachineCompareByType : IComparer<DrawningMachine?>
{
    public int Compare(DrawningMachine? x, DrawningMachine? y)
    {
        if (x == null || x.EntityGas == null)
        {
            return 1;
        }
        if (y == null || y.EntityGas == null)
        {
            return -1;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return y.GetType().Name.CompareTo(x.GetType().Name);
        }
        var speedCompare = y.EntityGas.Speed.CompareTo(x.EntityGas.Speed);
        if (speedCompare != 0)
        {
            return speedCompare;
        }
        return y.EntityGas.Weight.CompareTo(x.EntityGas.Weight);
    }
}
