﻿using ProjectGasMachine.Entities;
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectGasMachine.Drawnings;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawningMachineEqutables : IEqualityComparer<DrawningMachine?>
{
    public bool Equals(DrawningMachine? x, DrawningMachine? y)
    {
        if (x == null || x.EntityGas == null)
        {
            return false;
        }
        if (y == null || y.EntityGas == null)
        {
            return false;
        }
        if (x.GetType().Name != y.GetType().Name)
        {
            return false;
        }
        if (x.EntityGas.Speed != y.EntityGas.Speed)
        {
            return false;
        }
        if (x.EntityGas.Weight != y.EntityGas.Weight)
        {
            return false;
        }
        if (x.EntityGas.BodyColor != y.EntityGas.BodyColor)
        {
            return false;
        }
        if (x is DrawningGasMachine && y is DrawningGasMachine)
        {
            // TODO доделать логику сравнения дополнительных параметров
            if ((x.EntityGas as EntityMachine)?.AdditionalColor !=
                (y.EntityGas as EntityMachine)?.AdditionalColor)
            {
                return false;
            }
            if ((x.EntityGas as EntityMachine)?.Gas !=
                (y.EntityGas as EntityMachine)?.Gas)
            {
                return false;
            }
            if ((x.EntityGas as EntityMachine)?.Beacon !=
                (y.EntityGas as EntityMachine)?.Beacon)
            {
                return false;
            }
        }
        return true;
    }

    public int GetHashCode([DisallowNull] DrawningMachine? obj)
    {
        return obj.GetHashCode();
    }
}
